<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  creationComplete="creationCompleteHandler(event)" title="Cadastro de Status" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="StatusEntidadeIncluidoEvent")]
		[Event(name="StatusEntidadeAtualizadoEvent")]
		[Event(name="StatusEntidadeExcluidoEvent")]
		[Event(name="StatusEntidadeSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import br.com.desenv.nepalign.vo.StatusEntidade;
			
			// Alguem passa a objeto para ca
			public var statusEntidade : StatusEntidade = new StatusEntidade();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputDescricao.text = "";
				ignComboBoxFixoPermiteConsignacao.selectedIndex = -1;
				ignComboBoxFixoPermiteEmprestimo.selectedIndex = -1;
				ignComboBoxFixoPermitePagamentoParcelado.selectedIndex = -1;
				ignComboBoxFixoPermitePagamentoCartaoCred.selectedIndex = -1;
				ignComboBoxFixoPermitePagamentoCheque.selectedIndex = -1;
				ignComboBoxFixoBloquearVenda.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (this.statusEntidade.id == 0)
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputDescricao.text = this.statusEntidade.descricao;

					for(var i:int = 0; i < this.listaOpcaoPermiteConsignacao.length; i++)
					{
						if (this.listaOpcaoPermiteConsignacao.getItemAt(i).codigo == this.statusEntidade.permiteConsignacao)
						{
							ignComboBoxFixoPermiteConsignacao.selectedIndex = i;
							break;
						}
					}

					for(var i:int = 0; i < this.listaOpcaoPermiteEmprestimo.length; i++)
					{
						if (this.listaOpcaoPermiteEmprestimo.getItemAt(i).codigo == this.statusEntidade.permiteEmprestimo)
						{
							ignComboBoxFixoPermiteEmprestimo.selectedIndex = i;
							break;
						}
					}

					for(var i:int = 0; i < this.listaOpcaoPermitePagamentoParcelado.length; i++)
					{
						if (this.listaOpcaoPermitePagamentoParcelado.getItemAt(i).codigo == this.statusEntidade.permitePagamentoParcelado)
						{
							ignComboBoxFixoPermitePagamentoParcelado.selectedIndex = i;
							break;
						}
					}

					for(var i:int = 0; i < this.listaOpcaoPermitePagamentoCartaoCred.length; i++)
					{
						if (this.listaOpcaoPermitePagamentoCartaoCred.getItemAt(i).codigo == this.statusEntidade.permitePagamentoCartaoCred)
						{
							ignComboBoxFixoPermitePagamentoCartaoCred.selectedIndex = i;
							break;
						}
					}

					for(var i:int = 0; i < this.listaOpcaoPermitePagamentoCheque.length; i++)
					{
						if (this.listaOpcaoPermitePagamentoCheque.getItemAt(i).codigo == this.statusEntidade.permitePagamentoCheque)
						{
							ignComboBoxFixoPermitePagamentoCheque.selectedIndex = i;
							break;
						}
					}

					for(var i:int = 0; i < this.listaOpcaoBloquearVenda.length; i++)
					{
						if (this.listaOpcaoBloquearVenda.getItemAt(i).codigo == this.statusEntidade.bloquearVenda)
						{
							ignComboBoxFixoBloquearVenda.selectedIndex = i;
							break;
						}
					}

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (statusEntidade.id != 0) 
					{
						statusEntidade.descricao = ignTextInputDescricao.text;
						statusEntidade.permiteConsignacao = ignComboBoxFixoPermiteConsignacao.selectedItem==null?null:ignComboBoxFixoPermiteConsignacao.selectedItem.codigo == ""?null:ignComboBoxFixoPermiteConsignacao.selectedItem.codigo;
						statusEntidade.permiteEmprestimo = ignComboBoxFixoPermiteEmprestimo.selectedItem==null?null:ignComboBoxFixoPermiteEmprestimo.selectedItem.codigo == ""?null:ignComboBoxFixoPermiteEmprestimo.selectedItem.codigo;
						statusEntidade.permitePagamentoParcelado = ignComboBoxFixoPermitePagamentoParcelado.selectedItem==null?null:ignComboBoxFixoPermitePagamentoParcelado.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoParcelado.selectedItem.codigo;
						statusEntidade.permitePagamentoCartaoCred = ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem==null?null:ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem.codigo;
						statusEntidade.permitePagamentoCheque = ignComboBoxFixoPermitePagamentoCheque.selectedItem==null?null:ignComboBoxFixoPermitePagamentoCheque.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoCheque.selectedItem.codigo;
						statusEntidade.bloquearVenda = ignComboBoxFixoBloquearVenda.selectedItem==null?null:ignComboBoxFixoBloquearVenda.selectedItem.codigo == ""?null:ignComboBoxFixoBloquearVenda.selectedItem.codigo;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("statusEntidadeService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(statusEntidade); 
					// Se e inclusao
					} 
					else 
					{
						statusEntidade.descricao = ignTextInputDescricao.text;

						statusEntidade.permiteConsignacao = ignComboBoxFixoPermiteConsignacao.selectedItem==null?null:ignComboBoxFixoPermiteConsignacao.selectedItem.codigo == ""?null:ignComboBoxFixoPermiteConsignacao.selectedItem.codigo;

						statusEntidade.permiteEmprestimo = ignComboBoxFixoPermiteEmprestimo.selectedItem==null?null:ignComboBoxFixoPermiteEmprestimo.selectedItem.codigo == ""?null:ignComboBoxFixoPermiteEmprestimo.selectedItem.codigo;

						statusEntidade.permitePagamentoParcelado = ignComboBoxFixoPermitePagamentoParcelado.selectedItem==null?null:ignComboBoxFixoPermitePagamentoParcelado.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoParcelado.selectedItem.codigo;

						statusEntidade.permitePagamentoCartaoCred = ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem==null?null:ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoCartaoCred.selectedItem.codigo;

						statusEntidade.permitePagamentoCheque = ignComboBoxFixoPermitePagamentoCheque.selectedItem==null?null:ignComboBoxFixoPermitePagamentoCheque.selectedItem.codigo == ""?null:ignComboBoxFixoPermitePagamentoCheque.selectedItem.codigo;

						statusEntidade.bloquearVenda = ignComboBoxFixoBloquearVenda.selectedItem==null?null:ignComboBoxFixoBloquearVenda.selectedItem.codigo == ""?null:ignComboBoxFixoBloquearVenda.selectedItem.codigo;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("statusEntidadeService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(statusEntidade); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.statusEntidade = event.result as StatusEntidade;
				this.dispatchEvent(new ResultEvent("StatusEntidadeIncluidoEvent",false, true, this.statusEntidade, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.statusEntidade = event.result as StatusEntidade;
				this.dispatchEvent(new Event("StatusEntidadeAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoStatusEntidade" property="selectedItem" required="true" source="{comboBoxSituacaoStatusEntidade}" trigger="{comboBoxSituacaoStatusEntidade}" triggerEvent="valueCommit"/> -->
		
		<s:ArrayCollection id="listaOpcaoPermiteConsignacao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoPermiteEmprestimo">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoPermitePagamentoParcelado">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoPermitePagamentoCartaoCred">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoPermitePagamentoCheque">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
		<s:ArrayCollection id="listaOpcaoBloquearVenda">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="SIM"/>
			<fx:Object codigo="N" valor="NAO"/>
		</s:ArrayCollection>
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Status:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricao" styleName="labelValidacao" text="{ignTextInputDescricao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricao" maxChars="45" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Permitir Consignação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPermiteConsignacao" styleName="labelValidacao" text="{ignComboBoxFixoPermiteConsignacao.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPermiteConsignacao" obrigatorio="true"  dataProvider="{listaOpcaoPermiteConsignacao}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Permitir Empréstimo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPermiteEmprestimo" styleName="labelValidacao" text="{ignComboBoxFixoPermiteEmprestimo.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPermiteEmprestimo" obrigatorio="true"  dataProvider="{listaOpcaoPermiteEmprestimo}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Permitir Pagamento Parcelado:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPermitePagamentoParcelado" styleName="labelValidacao" text="{ignComboBoxFixoPermitePagamentoParcelado.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPermitePagamentoParcelado" obrigatorio="true"  dataProvider="{listaOpcaoPermitePagamentoParcelado}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Permitir Pagamento com Cartão de Crédito:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPermitePagamentoCartaoCred" styleName="labelValidacao" text="{ignComboBoxFixoPermitePagamentoCartaoCred.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPermitePagamentoCartaoCred" obrigatorio="true"  dataProvider="{listaOpcaoPermitePagamentoCartaoCred}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Permitir Pagamento Cheque:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPermitePagamentoCheque" styleName="labelValidacao" text="{ignComboBoxFixoPermitePagamentoCheque.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoPermitePagamentoCheque" obrigatorio="true"  dataProvider="{listaOpcaoPermitePagamentoCheque}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Bloquear Venda:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoBloquearVenda" styleName="labelValidacao" text="{ignComboBoxFixoBloquearVenda.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoBloquearVenda" obrigatorio="true"  dataProvider="{listaOpcaoBloquearVenda}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>